﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;

namespace WindowsFormsApplication39
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dt = DummyDataCreator.GetData(10);
            this.ultraGrid1.SetDataBinding(dt, null);

            this.ultraGrid1.CreationFilter = new MyCreationFilter();
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            UltraGridLayout layout = e.Layout;
            UltraGridBand band = layout.Bands[0];

            layout.ViewStyleBand = ViewStyleBand.OutlookGroupBy;

            layout.Override.SummaryDisplayArea = SummaryDisplayAreas.Bottom;

            band.SortedColumns.Add("Boolean 1", false, true);
            band.Summaries.Add( SummaryType.Sum, band.Columns["Int32 1"]);
        }
    }

    public class MyCreationFilter : IUIElementCreationFilter
    {
        #region IUIElementCreationFilter Members

        void IUIElementCreationFilter.AfterCreateChildElements(UIElement parent)
        {
            if (parent is SummaryFooterCaptionUIElement)
            {
                // Get the Text UIElement inside the summary footer caption UIElement. 
                TextUIElement textUIElement = parent.GetDescendant(typeof(TextUIElement)) as TextUIElement;

                if (textUIElement != null)                
                {
                    // Get the associated rows collection. 
                    RowsCollection rows = parent.GetContext(typeof(RowsCollection)) as RowsCollection;
                    if (rows != null)
                    {
                        // Get the GroupByRow which is the parent of the rows collection. 
                        UltraGridGroupByRow groupByRow = rows.ParentRow as UltraGridGroupByRow;
                        if (groupByRow != null)
                        {
                            // Set the text of the Text UIElement inside the SummaryFooterCaption to 
                            // the description text on the GroupByRow
                            textUIElement.Text = groupByRow.Description;
                        }
                    }
                }
            }
        }

        bool IUIElementCreationFilter.BeforeCreateChildElements(UIElement parent)
        {
            // Do nothing
            return false;
        }

        #endregion
    }

}
